#!/bin/bash

LIB="$(realpath $(dirname $0))"  # Absolute path
PROJ="$(dirname $LIB)"           # Game dir (..)
SRC="$PROJ"/../my_changes/          # My changes dir
DST="$PROJ"/mods/                # Game mods dir
#echo $LIB
#echo $PROJ
#echo $SRC
#echo $DST


#copy files
MOD_NAME=("skinsdb")    #temporary not used: "smart_inventory" "minetest_game"
MOD_TYPE=("player")           #temporary not used: "gui" "."


for MOD_INDEX in ${!MOD_NAME[*]}
do
    SRC_DIR="$SRC${MOD_TYPE[MOD_INDEX]}/${MOD_NAME[MOD_INDEX]}/"
    DST_DIR="$DST${MOD_TYPE[MOD_INDEX]}/${MOD_NAME[MOD_INDEX]}/"

    echo "---------------------"
    echo "Syncing ${MOD_NAME[MOD_INDEX]} mod changes."
    echo "$SRC_DIR --> $DST_DIR"

    rsync -r -v $SRC_DIR $DST_DIR
    echo "---------------------"
done

#patch code

MOD_TYPE=("mobs"  "buildings" "player" "player" "player")
MOD_NAME=("water_life" "doors" "3d_armor" "hbsprint" "hunger_ng")
MOD_PATCH=("poison.patch" "doors_update.patch" "mob_damage.patch" "no_damage.patch" "effects.patch")

for MOD_INDEX in ${!MOD_NAME[*]}
do
    SRC_DIR="$SRC${MOD_TYPE[MOD_INDEX]}/${MOD_NAME[MOD_INDEX]}/"
    DST_DIR="$DST${MOD_TYPE[MOD_INDEX]}/${MOD_NAME[MOD_INDEX]}/"

    echo "---------------------"
    echo "Apllying patch to ${MOD_NAME[MOD_INDEX]}."
    echo
	
	cd $DST_DIR
	
	patch -p1 < "$SRC_DIR/${MOD_PATCH[MOD_INDEX]}"

    echo "---------------------"
done 
